'                                                                  
' Copyright  2005 Lidor Systems.
' All Rights Reserved.
'
' This file is part of the "LidorSystems.Collector" class Library. 
'                                                                   
' The contents of this file are subject to the LidorSystems.Collector
' License (the "License"), and may not be used except in compliance
' with the License. A copy of the License should have been installed
' in the product's root installation directory. You may also obtain a
' copy of the License at...
'                                                                   
' http:'www.lidorsystems.com/products/collector/agreement.html
'                                                             
' Software distributed under this License is distributed on an 
' "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
' implied. See the License for the specific language governing 
' rights and limitations under the License.                        
' 

Imports LidorSystems.Collector
Imports LidorSystems.Collector.Style

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents group1 As LidorSystems.Collector.Group
    Friend WithEvents page1 As LidorSystems.Collector.Page
    Friend WithEvents page2 As LidorSystems.Collector.Page
    Friend WithEvents page3 As LidorSystems.Collector.Page
    Friend WithEvents pgPanel As LidorSystems.Collector.Page
    Friend WithEvents btnCreateVertical As System.Windows.Forms.Button
    Friend WithEvents groupBox2 As System.Windows.Forms.GroupBox
    Friend WithEvents label3 As System.Windows.Forms.Label
    Friend WithEvents visualStyle As System.Windows.Forms.ComboBox
    Friend WithEvents useTheme As System.Windows.Forms.CheckBox
    Friend WithEvents label1 As System.Windows.Forms.Label
    Friend WithEvents colorScheme As System.Windows.Forms.ComboBox
    Friend WithEvents groupBox1 As System.Windows.Forms.GroupBox
    Friend WithEvents btnApply As System.Windows.Forms.Button
    Friend WithEvents rbBottom As System.Windows.Forms.RadioButton
    Friend WithEvents rbRight As System.Windows.Forms.RadioButton
    Friend WithEvents rbTop As System.Windows.Forms.RadioButton
    Friend WithEvents rbLeft As System.Windows.Forms.RadioButton
    Friend WithEvents btnCreateHorizontal As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.group1 = New LidorSystems.Collector.Group
        Me.page1 = New LidorSystems.Collector.Page
        Me.page2 = New LidorSystems.Collector.Page
        Me.page3 = New LidorSystems.Collector.Page
        Me.pgPanel = New LidorSystems.Collector.Page
        Me.btnCreateVertical = New System.Windows.Forms.Button
        Me.groupBox2 = New System.Windows.Forms.GroupBox
        Me.label3 = New System.Windows.Forms.Label
        Me.visualStyle = New System.Windows.Forms.ComboBox
        Me.useTheme = New System.Windows.Forms.CheckBox
        Me.label1 = New System.Windows.Forms.Label
        Me.colorScheme = New System.Windows.Forms.ComboBox
        Me.groupBox1 = New System.Windows.Forms.GroupBox
        Me.btnApply = New System.Windows.Forms.Button
        Me.rbBottom = New System.Windows.Forms.RadioButton
        Me.rbRight = New System.Windows.Forms.RadioButton
        Me.rbTop = New System.Windows.Forms.RadioButton
        Me.rbLeft = New System.Windows.Forms.RadioButton
        Me.btnCreateHorizontal = New System.Windows.Forms.Button
        CType(Me.group1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.group1.SuspendLayout()
        Me.pgPanel.SuspendLayout()
        Me.groupBox2.SuspendLayout()
        Me.groupBox1.SuspendLayout()
        Me.SuspendLayout()
        '
        'group1
        '
        Me.group1.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.group1.Controls.Add(Me.page1)
        Me.group1.Controls.Add(Me.page2)
        Me.group1.Controls.Add(Me.page3)
        Me.group1.ControlState = LidorSystems.Collector.ControlState.Docked
        Me.group1.Cursor = System.Windows.Forms.Cursors.Default
        Me.group1.Dock = System.Windows.Forms.DockStyle.Fill
        Me.group1.Header = False
        Me.group1.Location = New System.Drawing.Point(0, 0)
        Me.group1.Name = "group1"
        Me.group1.Pages.AddRange(New LidorSystems.Collector.Page() {Me.page1, Me.page2, Me.page3})
        Me.group1.SelectedPage = Me.page1
        Me.group1.Size = New System.Drawing.Size(421, 414)
        Me.group1.TabIndex = 4
        Me.group1.Text = "group1"
        '
        'page1
        '
        Me.page1.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.page1.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!)
        Me.page1.Location = New System.Drawing.Point(1, 22)
        Me.page1.Name = "page1"
        Me.page1.Size = New System.Drawing.Size(419, 391)
        Me.page1.StyleFromParent = True
        Me.page1.TabIndex = 0
        Me.page1.TableObject = Nothing
        Me.page1.Text = "page1"
        '
        'page2
        '
        Me.page2.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.page2.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!)
        Me.page2.Location = New System.Drawing.Point(1, 22)
        Me.page2.Name = "page2"
        Me.page2.Size = New System.Drawing.Size(419, 391)
        Me.page2.StyleFromParent = True
        Me.page2.TabIndex = 1
        Me.page2.TableObject = Nothing
        Me.page2.Text = "page2"
        '
        'page3
        '
        Me.page3.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.page3.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!)
        Me.page3.Location = New System.Drawing.Point(1, 22)
        Me.page3.Name = "page3"
        Me.page3.Size = New System.Drawing.Size(419, 391)
        Me.page3.StyleFromParent = True
        Me.page3.TabIndex = 2
        Me.page3.TableObject = Nothing
        Me.page3.Text = "page3"
        '
        'pgPanel
        '
        Me.pgPanel.Controls.Add(Me.btnCreateVertical)
        Me.pgPanel.Controls.Add(Me.groupBox2)
        Me.pgPanel.Controls.Add(Me.groupBox1)
        Me.pgPanel.Controls.Add(Me.btnCreateHorizontal)
        Me.pgPanel.Dock = System.Windows.Forms.DockStyle.Right
        Me.pgPanel.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!)
        Me.pgPanel.Location = New System.Drawing.Point(421, 0)
        Me.pgPanel.Name = "pgPanel"
        Me.pgPanel.Size = New System.Drawing.Size(179, 414)
        Me.pgPanel.TabIndex = 3
        Me.pgPanel.TableObject = Nothing
        Me.pgPanel.Text = "page1"
        '
        'btnCreateVertical
        '
        Me.btnCreateVertical.BackColor = System.Drawing.SystemColors.Control
        Me.btnCreateVertical.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.btnCreateVertical.Location = New System.Drawing.Point(10, 372)
        Me.btnCreateVertical.Name = "btnCreateVertical"
        Me.btnCreateVertical.Size = New System.Drawing.Size(160, 24)
        Me.btnCreateVertical.TabIndex = 2
        Me.btnCreateVertical.Text = "New Vertical Tab Group"
        '
        'groupBox2
        '
        Me.groupBox2.Controls.Add(Me.label3)
        Me.groupBox2.Controls.Add(Me.visualStyle)
        Me.groupBox2.Controls.Add(Me.useTheme)
        Me.groupBox2.Controls.Add(Me.label1)
        Me.groupBox2.Controls.Add(Me.colorScheme)
        Me.groupBox2.Location = New System.Drawing.Point(8, 170)
        Me.groupBox2.Name = "groupBox2"
        Me.groupBox2.Size = New System.Drawing.Size(164, 156)
        Me.groupBox2.TabIndex = 1
        Me.groupBox2.TabStop = False
        Me.groupBox2.Text = "Style"
        '
        'label3
        '
        Me.label3.Location = New System.Drawing.Point(12, 26)
        Me.label3.Name = "label3"
        Me.label3.Size = New System.Drawing.Size(82, 16)
        Me.label3.TabIndex = 0
        Me.label3.Text = "Visual style"
        Me.label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'visualStyle
        '
        Me.visualStyle.Items.AddRange(New Object() {"Default", "Classic", "Office2003", "VS2003", "VS2005"})
        Me.visualStyle.Location = New System.Drawing.Point(12, 44)
        Me.visualStyle.Name = "visualStyle"
        Me.visualStyle.Size = New System.Drawing.Size(116, 23)
        Me.visualStyle.TabIndex = 1
        Me.visualStyle.Text = "Default"
        '
        'useTheme
        '
        Me.useTheme.Location = New System.Drawing.Point(12, 72)
        Me.useTheme.Name = "useTheme"
        Me.useTheme.Size = New System.Drawing.Size(102, 24)
        Me.useTheme.TabIndex = 2
        Me.useTheme.Text = "Use Themes"
        '
        'label1
        '
        Me.label1.Location = New System.Drawing.Point(12, 102)
        Me.label1.Name = "label1"
        Me.label1.Size = New System.Drawing.Size(82, 16)
        Me.label1.TabIndex = 3
        Me.label1.Text = "Color scheme"
        Me.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'colorScheme
        '
        Me.colorScheme.Items.AddRange(New Object() {"Default", "Carrot", "Coral", "DarkForest", "DarkWood", "DeepSea", "Forest", "Gold", "GoldRose", "Lily", "Metalic", "Midnight", "Rose", "Sand", "Sea", "Silver", "Sky", "Strawberry", "Sunset", "Vinegar", "Violet", "Wood"})
        Me.colorScheme.Location = New System.Drawing.Point(12, 120)
        Me.colorScheme.Name = "colorScheme"
        Me.colorScheme.Size = New System.Drawing.Size(116, 23)
        Me.colorScheme.TabIndex = 4
        Me.colorScheme.Text = "Default"
        '
        'groupBox1
        '
        Me.groupBox1.Controls.Add(Me.btnApply)
        Me.groupBox1.Controls.Add(Me.rbBottom)
        Me.groupBox1.Controls.Add(Me.rbRight)
        Me.groupBox1.Controls.Add(Me.rbTop)
        Me.groupBox1.Controls.Add(Me.rbLeft)
        Me.groupBox1.Location = New System.Drawing.Point(8, 6)
        Me.groupBox1.Name = "groupBox1"
        Me.groupBox1.Size = New System.Drawing.Size(164, 160)
        Me.groupBox1.TabIndex = 0
        Me.groupBox1.TabStop = False
        Me.groupBox1.Text = "Tab Orientation"
        '
        'btnApply
        '
        Me.btnApply.BackColor = System.Drawing.SystemColors.Control
        Me.btnApply.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.btnApply.Location = New System.Drawing.Point(80, 126)
        Me.btnApply.Name = "btnApply"
        Me.btnApply.Size = New System.Drawing.Size(72, 24)
        Me.btnApply.TabIndex = 4
        Me.btnApply.Text = "Apply"
        '
        'rbBottom
        '
        Me.rbBottom.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.rbBottom.Location = New System.Drawing.Point(12, 94)
        Me.rbBottom.Name = "rbBottom"
        Me.rbBottom.Size = New System.Drawing.Size(94, 24)
        Me.rbBottom.TabIndex = 3
        Me.rbBottom.Text = "Bottom"
        '
        'rbRight
        '
        Me.rbRight.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.rbRight.Location = New System.Drawing.Point(12, 70)
        Me.rbRight.Name = "rbRight"
        Me.rbRight.Size = New System.Drawing.Size(94, 24)
        Me.rbRight.TabIndex = 2
        Me.rbRight.Text = "Right"
        '
        'rbTop
        '
        Me.rbTop.Checked = True
        Me.rbTop.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.rbTop.Location = New System.Drawing.Point(12, 46)
        Me.rbTop.Name = "rbTop"
        Me.rbTop.Size = New System.Drawing.Size(94, 24)
        Me.rbTop.TabIndex = 1
        Me.rbTop.TabStop = True
        Me.rbTop.Text = "Top"
        '
        'rbLeft
        '
        Me.rbLeft.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.rbLeft.Location = New System.Drawing.Point(12, 22)
        Me.rbLeft.Name = "rbLeft"
        Me.rbLeft.Size = New System.Drawing.Size(94, 24)
        Me.rbLeft.TabIndex = 0
        Me.rbLeft.Text = "Left"
        '
        'btnCreateHorizontal
        '
        Me.btnCreateHorizontal.BackColor = System.Drawing.SystemColors.Control
        Me.btnCreateHorizontal.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.btnCreateHorizontal.Location = New System.Drawing.Point(10, 338)
        Me.btnCreateHorizontal.Name = "btnCreateHorizontal"
        Me.btnCreateHorizontal.Size = New System.Drawing.Size(160, 24)
        Me.btnCreateHorizontal.TabIndex = 0
        Me.btnCreateHorizontal.Text = "New Horizontal Tab Group"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(600, 414)
        Me.Controls.Add(Me.group1)
        Me.Controls.Add(Me.pgPanel)
        Me.Name = "Form1"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Tabbed MDI"
        CType(Me.group1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.group1.ResumeLayout(False)
        Me.pgPanel.ResumeLayout(False)
        Me.groupBox2.ResumeLayout(False)
        Me.groupBox1.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

#Region "Tab Orientation"
    Private Sub btnApply_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnApply.Click
        If rbLeft.Checked Then
            ChangeOrientation(TabOrientation.Left)
        ElseIf rbTop.Checked Then
            ChangeOrientation(TabOrientation.Top)
        ElseIf rbRight.Checked Then
            ChangeOrientation(TabOrientation.Right)
        ElseIf rbBottom.Checked Then
            ChangeOrientation(TabOrientation.Bottom)
        End If
    End Sub

    Private Sub ChangeOrientation(ByVal orientation As TabOrientation)
        Dim currentGroup As Group = Nothing
        For Each ctrl As Control In Me.Controls
            If TypeOf ctrl Is Group Then
                currentGroup = CType(ctrl, Group)
                If Not (currentGroup.Style Is Nothing) Then
                    currentGroup.Style.Orientation = orientation
                End If
            End If
        Next
    End Sub
#End Region

#Region "Style"
    Private Function GetCurrentVisualStyle() As visualStyle
        Dim vStyle As VisualStyle = LidorSystems.Collector.Style.VisualStyle.Default
        Select Case visualStyle.SelectedItem.ToString
            Case "Classic"
                vStyle = LidorSystems.Collector.Style.VisualStyle.Classic
            Case "Office2003"
                vStyle = LidorSystems.Collector.Style.VisualStyle.Office2003
            Case "VS2003"
                vStyle = LidorSystems.Collector.Style.VisualStyle.VS2003
            Case "VS2005"
                vStyle = LidorSystems.Collector.Style.VisualStyle.VS2005
            Case Else
                vStyle = LidorSystems.Collector.Style.VisualStyle.Default
        End Select
        Return vStyle
    End Function

    Private Sub visualStyle_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles visualStyle.SelectedIndexChanged
        Dim vStyle As VisualStyle = GetCurrentVisualStyle()
        For Each ctrl As Control In Me.Controls
            If TypeOf ctrl Is Group Then
                CType(ctrl, Group).VisualStyle = vStyle
            ElseIf TypeOf ctrl Is Page Then
                CType(ctrl, Page).VisualStyle = vStyle
            End If
        Next
    End Sub

    Private Sub useTheme_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles useTheme.CheckedChanged
        For Each ctrl As Control In Me.Controls
            If TypeOf ctrl Is Group Then
                CType(ctrl, Group).UseTheme = useTheme.Checked
            ElseIf TypeOf ctrl Is Page Then
                CType(ctrl, Page).UseTheme = useTheme.Checked
            End If
        Next
    End Sub

    Private Function GetCurrentColorScheme() As colorScheme
        Dim scheme As ColorScheme = LidorSystems.Collector.Style.ColorScheme.Default
        Select Case colorScheme.SelectedItem.ToString
            Case "Carrot"
                scheme = LidorSystems.Collector.Style.ColorScheme.Carrot
            Case "Coral"
                scheme = LidorSystems.Collector.Style.ColorScheme.Coral
            Case "DarkForest"
                scheme = LidorSystems.Collector.Style.ColorScheme.DarkForest
            Case "DarkWood"
                scheme = LidorSystems.Collector.Style.ColorScheme.DarkWood
            Case "DeepSea"
                scheme = LidorSystems.Collector.Style.ColorScheme.DeepSea
            Case "Forest"
                scheme = LidorSystems.Collector.Style.ColorScheme.Forest
            Case "Gold"
                scheme = LidorSystems.Collector.Style.ColorScheme.Gold
            Case "GoldRose"
                scheme = LidorSystems.Collector.Style.ColorScheme.GoldRose
            Case "Lily"
                scheme = LidorSystems.Collector.Style.ColorScheme.Lily
            Case "Metalic"
                scheme = LidorSystems.Collector.Style.ColorScheme.Metalic
            Case "Midnight"
                scheme = LidorSystems.Collector.Style.ColorScheme.Midnight
            Case "Rose"
                scheme = LidorSystems.Collector.Style.ColorScheme.Rose
            Case "Sand"
                scheme = LidorSystems.Collector.Style.ColorScheme.Sand
            Case "Sea"
                scheme = LidorSystems.Collector.Style.ColorScheme.Sea
            Case "Silver"
                scheme = LidorSystems.Collector.Style.ColorScheme.Silver
            Case "Strawberry"
                scheme = LidorSystems.Collector.Style.ColorScheme.Strawberry
            Case "Sunset"
                scheme = LidorSystems.Collector.Style.ColorScheme.Sunset
            Case "Vinegar"
                scheme = LidorSystems.Collector.Style.ColorScheme.Vinegar
            Case "Violet"
                scheme = LidorSystems.Collector.Style.ColorScheme.Violet
            Case "Wood"
                scheme = LidorSystems.Collector.Style.ColorScheme.Wood
            Case Else
                scheme = LidorSystems.Collector.Style.ColorScheme.Default
        End Select

        Return scheme
    End Function

    Private Sub colorScheme_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles colorScheme.SelectedIndexChanged
        Dim scheme As ColorScheme = GetCurrentColorScheme()
        For Each ctrl As Control In Me.Controls
            If TypeOf ctrl Is Group Then
                If Not (CType(ctrl, Group).Style Is Nothing) Then
                    CType(ctrl, Group).Style.ColorScheme = scheme
                End If
            ElseIf TypeOf ctrl Is Page Then
                If Not (CType(ctrl, Page).Style Is Nothing) Then
                    CType(ctrl, Page).Style.ColorScheme = scheme
                End If
            End If
        Next
    End Sub
#End Region

#Region "New Tab Group"
    Private Sub btnCreateHorizontal_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCreateHorizontal.Click
        CreateNewTabGroup(DockStyle.Bottom)
    End Sub

    Private Sub btnCreateVertical_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCreateVertical.Click
        CreateNewTabGroup(DockStyle.Right)
    End Sub
    Private Sub CreateNewTabGroup(ByVal dock As DockStyle)
        Dim newGroup As Group = New Group
        newGroup.Text = "Group" + CType((Me.Controls.Count + 1), Integer).ToString
        newGroup.Header = False
        newGroup.BorderStyle = BorderStyle.None
        newGroup.Dock = dock
        If Not (newGroup.Style Is Nothing) Then
            If rbLeft.Checked Then
                newGroup.Style.Orientation = TabOrientation.Left
            Else
                If rbTop.Checked Then
                    newGroup.Style.Orientation = TabOrientation.Top
                Else
                    If rbRight.Checked Then
                        newGroup.Style.Orientation = TabOrientation.Right
                    Else
                        If rbBottom.Checked Then
                            newGroup.Style.Orientation = TabOrientation.Bottom
                        End If
                    End If
                End If
            End If
            newGroup.Style.ColorScheme = GetCurrentColorScheme()
        End If
        newGroup.VisualStyle = GetCurrentVisualStyle()
        newGroup.UseTheme = useTheme.Checked
        Dim fillGroup As Group = Nothing
        For Each ctrl As Control In Me.Controls
            If TypeOf ctrl Is Group AndAlso ctrl.Dock = DockStyle.Fill Then
                fillGroup = CType(ctrl, Group)
                Exit For
            End If
        Next
        If Not (fillGroup Is Nothing) Then
            Select Case dock
                Case DockStyle.Right
                    newGroup.Size = New Size(fillGroup.Width / 2, fillGroup.Height)
                Case DockStyle.Bottom
                    newGroup.Size = New Size(fillGroup.Width, fillGroup.Height / 2)
            End Select
        Else
            newGroup.Size = New Size(100, 100)
        End If
        Dim newPage As Page = New Page
        newPage.Text = "Page1"
        newPage.StyleFromParent = True
        newGroup.Pages.Add(newPage)
        newGroup.Hide()
        Me.Controls.Add(newGroup)
        If Not (fillGroup Is Nothing) Then
            Me.Controls.SetChildIndex(newGroup, Me.Controls.IndexOf(fillGroup) + 1)
        Else
            If Not (Me.pgPanel Is Nothing) AndAlso Not Me.pgPanel.IsDisposed Then
                Me.Controls.SetChildIndex(newGroup, Me.Controls.IndexOf(Me.pgPanel))
            End If
        End If
        newGroup.Show()
        newPage.Focus()
    End Sub
#End Region

End Class
